unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Menus, synaser, BaseUnix, LazFileUtils, Input;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    SubMenuItemArray: array[0..31]  of TMenuItem;

    procedure MenuItemClick(Sender:TObject);

  public
    ser: TBlockSerial;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

//function GetSerialPortNames: string;
//type
//TSerialStruct = packed record
//  typ: Integer;
//  line: Integer;
//  port: Cardinal;
//  irq: Integer;
//  flags: Integer;
//  xmit_fifo_size: Integer;
//  custom_divisor: Integer;
//  baud_base: Integer;
//  close_delay: Word;
//  io_type: Char;
//  reserved_char: Char;
//  hub6: Integer;
//  closing_wait: Word; // time to wait before closing
//  closing_wait2: Word; // no longer used...
//  iomem_base: ^Char;
//  iomem_reg_shift: Word;
//  port_high: Cardinal;
//  iomap_base: LongWord; // cookie passed into ioremap
//end;
//var
//  i: Integer;
//  sr : TSearchRec;
//  sl: TStringList;
//  st: stat;
//  s: String;
//  fd: PtrInt;
//  Ser : TSerialStruct;
//const TIOCGSERIAL = $541E;
//  PORT_UNKNOWN = 0;
//begin
//  Result := '';
//  sl := TStringList.Create;
//  try
//    // 1. Alle möglichen Ports finden
//    if FindFirst('/sys/class/tty/*', LongInt($FFFFFFFF), sr) = 0 then
//    begin
//      repeat
//        if (sr.Name <> '.') and (sr.Name <> '..') Then
//          if (sr.Attr and LongInt($FFFFFFFF)) = Sr.Attr then
//            sl.Add(sr.Name);
//      until FindNext(sr) <> 0;
//    end;
//    FindClose(sr);
//    // 2. heraussuchen ob ./device/driver vorhanden ist
//    for i := sl.Count - 1 Downto 0 Do
//    Begin
//      If Not DirectoryExists('/sys/class/tty/' + sl[i] + '/device/driver') Then
//        sl.Delete(i); // Nicht vorhanden >> Port existiert nicht
//    end;
//    // 3. Herausfinden welcher Treiber
//    st.st_mode := 0;
//    for i := sl.Count - 1 Downto 0 Do
//    Begin
//      IF fpLstat('/sys/class/tty/' + sl[i] + '/device', st) = 0 Then
//      Begin
//        if fpS_ISLNK(st.st_mode) Then
//        Begin
//          s := fpReadLink('/sys/class/tty/' + sl[i] + '/device/driver');
//          s := ExtractFileName(s);
//          // 4. Bei serial8250 Treiber muss der Port geprüft werden
//          If s = 'serial8250' Then
//          Begin
//            sl.Objects[i] := TObject(PtrInt(1));
//            fd := FpOpen('/dev/' + sl[i], O_RDWR Or O_NONBLOCK Or O_NOCTTY);
//            If fd > 0 Then
//            Begin
//              If FpIOCtl(fd, TIOCGSERIAL, @Ser) = 0 Then
//              Begin
//                If Ser.typ = PORT_UNKNOWN Then // PORT_UNKNOWN
//                  sl.Delete(i);
//              end;
//              FpClose(fd);
//            end else sl.Delete(i); // Port kann nicht geöffnet werden
//          end;
//        End;
//      end;
//    end;
//    // 5. Dev anhängen
//    for i := 0 To sl.Count - 1 Do
//      sl[i] := '/dev/' + sl[i];
//   Result := sl.CommaText;
//  finally
//    sl.Free;
//  end;
//end;

procedure TForm1.FormCreate(Sender: TObject);
var
  sl: TStringList;
  i: integer;
begin

  for i := 0 to Length(SubMenuItemArray)-1 do begin
    SubMenuItemArray[i] := TMenuItem.Create(Self);
    with SubMenuItemArray[i] do begin
      Caption:='<CTRL+'+char(i+64)+'>';
      Tag:=i;
      OnClick:=@MenuItemClick;
    end;
    MenuItem1.Insert(i, SubMenuItemArray[i]);
  end;


  ComboBox1.Items.CommaText := GetSerialPortNames;
//ComboBox1.Items.CommaText:=synaser.GetSerialPortNames;

  ser := TBlockSerial.Create;
  ser.LinuxLock := False;
  ser.Purge;

  {$IFDEF MSWINDOWS}
  ser.Connect('COM8');
  {$ELSE}
  ser.Connect('/dev/ttyACM2');
  {$ENDIF}

  Sleep(1000);
  //ser.Config(9600, 8, 'N', SB1, False, False);
    ser.Config(115200, 8, 'N', SB1, False, False);

  Memo1.Lines.Add('Device: ' + ser.Device + '   Status: ' + ser.LastErrorDesc + ' ' + IntToStr(ser.LastError));
  Sleep(1000);
  Timer1.Interval := 100;
  Timer1.Enabled := True;

  Memo1.DoubleBuffered := True;

end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  InputForm.Show;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Timer1.Enabled := False;
  ser.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ser.SendBuffer(Pointer(Edit1.Text), Length(Edit1.Text));
  //  Caption:=IntToStr(Memo1.Lines.Count);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  s: string;
  l: integer;
begin
  while Timer1.Enabled and (ser.CanRead(10)) do begin
    l := ser.WaitingData;
    SetLength(s, l);
    ser.RecvBuffer(@s[1], l);
    Memo1.Text := Memo1.Text + s;
    if CheckBox1.Checked then begin
      Memo1.SelStart := -2;
      //      Memo1.SelStart := Length(Memo1.Text);
    end;
    Application.ProcessMessages;
  end;
end;

procedure TForm1.MenuItemClick(Sender: TObject);
begin
  Caption:=IntToStr( TMenuItem(Sender).Tag);
end;

end.
